"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var popover_container_component_1 = require("./popover-container.component");
var popover_options_class_1 = require("./popover-options.class");
var Popover = (function () {
    function Popover(viewContainerRef, resolver) {
        this.visible = false;
        this.popoverAnimation = true;
        this.popoverPlacement = "bottom";
        this.popoverOnHover = false;
        this.popoverCloseOnClickOutside = false;
        this.popoverCloseOnMouseOutside = false;
        this.viewContainerRef = viewContainerRef;
        this.resolver = resolver;
    }
    Popover.prototype.showOrHideOnClick = function () {
        if (this.popoverOnHover)
            return;
        if (this.popoverDisabled)
            return;
        if (!this.visible) {
            this.show();
        }
        else {
            this.hide();
        }
    };
    // params event, target
    Popover.prototype.showOnHover = function () {
        if (!this.popoverOnHover || this.popoverDisabled || this.visible)
            return;
        this.show();
    };
    // params event, target
    Popover.prototype.hideOnHover = function () {
        if (this.popoverCloseOnMouseOutside
            || !this.popoverOnHover
            || this.popoverDisabled
            || !this.visible)
            return; // don't do anything since not we control this
        this.hide();
    };
    Popover.prototype.show = function () {
        var _this = this;
        this.visible = true;
        this.getInstance().then(function (popoverInstance) {
            Object.assign(popoverInstance, _this.setOptions());
            popoverInstance.onCloseFromOutside.subscribe(function () { return _this.hide(); });
            popoverInstance.show();
        });
    };
    Popover.prototype.getInstance = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.content && typeof _this.content !== "string") {
                resolve(_this.content);
            }
            else {
                _this.resolver.resolveComponent(popover_container_component_1.PopoverContent).then(function (factory) {
                    _this.popover = _this.viewContainerRef.createComponent(factory);
                    resolve(_this.popover.instance);
                });
            }
        });
    };
    Popover.prototype.hide = function () {
        this.visible = false;
        if (this.popover)
            this.popover.destroy();
        if (this.content instanceof popover_container_component_1.PopoverContent)
            this.content.hide();
    };
    Popover.prototype.setOptions = function () {
        var options = new popover_options_class_1.PopoverOptions({
            content: this.content,
            title: this.popoverTitle,
            placement: this.popoverPlacement,
            animation: this.popoverAnimation,
            closeOnClickOutside: this.popoverCloseOnClickOutside,
            closeOnMouseOutside: this.popoverCloseOnMouseOutside,
            hostElement: this.viewContainerRef.element.nativeElement
        });
        return options;
    };
    __decorate([
        core_1.Input("popover"), 
        __metadata('design:type', Object)
    ], Popover.prototype, "content", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Popover.prototype, "popoverDisabled", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Popover.prototype, "popoverAnimation", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], Popover.prototype, "popoverPlacement", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Popover.prototype, "popoverTitle", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Popover.prototype, "popoverOnHover", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Popover.prototype, "popoverCloseOnClickOutside", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Popover.prototype, "popoverCloseOnMouseOutside", void 0);
    __decorate([
        core_1.HostListener("click"), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], Popover.prototype, "showOrHideOnClick", null);
    __decorate([
        core_1.HostListener('focusin', ['$event', '$target']),
        core_1.HostListener('mouseenter', ['$event', '$target']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], Popover.prototype, "showOnHover", null);
    __decorate([
        core_1.HostListener('focusout', ['$event', '$target']),
        core_1.HostListener('mouseleave', ['$event', '$target']), 
        __metadata('design:type', Function), 
        __metadata('design:paramtypes', []), 
        __metadata('design:returntype', void 0)
    ], Popover.prototype, "hideOnHover", null);
    Popover = __decorate([
        core_1.Directive({ selector: "[popover]" }), 
        __metadata('design:paramtypes', [core_1.ViewContainerRef, core_1.ComponentResolver])
    ], Popover);
    return Popover;
}());
exports.Popover = Popover;
