var webpack = require("webpack");
var path = require('path');
module.exports = {
  entry: {
    "vendor": "./src/demo/vendor",
    "app": "./src/demo/app"
  },
  output: {
    path: __dirname,
    filename: "[name].bundle.js"
  },
  resolve: {
    extensions: ['', '.ts', '.js']
  },
  module: {
    loaders: [{
      test: /\.ts/,
      loaders: ['ts-loader'],
      exclude: [path.join(__dirname, 'build'), path.join(__dirname, 'node_modules')]
    }]
  },
  plugins: [
    new webpack.optimize.CommonsChunkPlugin( /* chunkName= */ "vendor", /* filename= */ "vendor.bundle.js", Infinity)
  ]
}
